## libmygpo-qt 1.2.0

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 3.5 FATAL_ERROR )

project( libmygpo-qt )

set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII" )

option(BUILD_WITH_QT6 "Build libmygpo-qt with Qt6" OFF)
option(MYGPO_BUILD_TESTS "Build all unit tests" ON)

if( NOT BUILD_WITH_QT6 )
    if( MYGPO_BUILD_TESTS )
        find_package(Qt5 5.15.0 REQUIRED COMPONENTS Core Network Test CONFIG)
    else()
        find_package(Qt5 5.15.0 REQUIRED COMPONENTS Core Network CONFIG)
    endif()
    set(MYGPO_QT_VERSION_SUFFIX 5)

    macro(qt_wrap_cpp)
        qt5_wrap_cpp(${ARGN})
    endmacro()

    # pkg-config names of QtCore and QtNetwork are Qt5Core and Qt5Network for
    # Qt5
    set(MYGPO_QT_MAJOR_VERSION "5")
else()
    message(STATUS "Could not find Qt5, searching for Qt6 instead...")
    if( MYGPO_BUILD_TESTS )
        find_package( Qt6 COMPONENTS Core Network Test REQUIRED )
    else( MYGPO_BUILD_TESTS )
        find_package( Qt6 COMPONENTS Core Network REQUIRED )
    endif()
    set(MYGPO_QT_VERSION_SUFFIX 6)

    macro(qt_wrap_cpp)
        qt6_wrap_cpp(${ARGN})
    endmacro()

    set(MYGPO_QT_MAJOR_VERSION "6")

endif()

# Don't use absolute path in Mygpo-qtTargets-$buildType.cmake
# (This will have no effect with CMake < 2.8)
# set(QT_USE_IMPORTED_TARGETS TRUE)

set( MYGPO_QT_VERSION_MAJOR "1" )
set( MYGPO_QT_VERSION_MINOR "2" )
set( MYGPO_QT_VERSION_PATCH "0" )
set( MYGPO_QT_VERSION "${MYGPO_QT_VERSION_MAJOR}.${MYGPO_QT_VERSION_MINOR}.${MYGPO_QT_VERSION_PATCH}" )

set( MYGPO_QT_SONAME "${MYGPO_QT_VERSION_MAJOR}")

#Configure Version.h.in with the actual version number
configure_file( src/Version.h.in ${CMAKE_CURRENT_BINARY_DIR}/src/Version.h )

include(CheckCXXCompilerFlag)

if (CMAKE_COMPILER_IS_GNUCXX)
    ADD_DEFINITIONS( -Wcast-align -Wchar-subscripts -Wpointer-arith
       -Wwrite-strings -Wpacked -Wformat-security -Wmissing-format-attribute
       -Wold-style-cast -Woverloaded-virtual -Wnon-virtual-dtor  -Wall -Wextra
       -Wformat=2 -Wundef -Wstack-protector -Wmissing-include-dirs
       -Winit-self -Wunsafe-loop-optimizations  -ggdb3 -fno-inline -DQT_STRICT_ITERATORS )
    if ( NOT WIN32 )
        add_definitions( -fvisibility=hidden )
    endif()

    check_cxx_compiler_flag( -Wlogical-op GNUCXX_HAS_WLOGICAL_OP )
    if ( GNUCXX_HAS_WLOGICAL_OP )
        add_definitions( -Wlogical-op )
    endif()
endif(CMAKE_COMPILER_IS_GNUCXX)

if(MYGPO_BUILD_TESTS)
    INCLUDE(CTest)
    enable_testing()
endif(MYGPO_BUILD_TESTS)

set( CPACK_GENERATOR "TBZ2" "DEB" )
set( CPACK_PACKAGE_VERSION_MAJOR "${MYGPO_QT_VERSION_MAJOR}" )
set( CPACK_PACKAGE_VERSION_MINOR "${MYGPO_QT_VERSION_MINOR}" )
set( CPACK_PACKAGE_VERSION_PATCH "${MYGPO_QT_VERSION_PATCH}" )
set( CPACK_PACKAGE_VERSION "${MYGPO_QT_VERSION}" )
set( CPACK_DEBIAN_PACKAGE_MAINTAINER "gpodder@freelists.org" )
set( CPACK_PACKAGE_DESCRIPTION_SUMMARY "A c++/qt library to access the APIs provided by gpodder.net." )

set(LIB_SUFFIX "" CACHE STRING "The directories where to install libraries to")
set(LIB_INSTALL_DIR lib${LIB_SUFFIX} )
set(LIB_DIR_PKGCONF "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")
set(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include/mygpo-qt${MYGPO_QT_VERSION_SUFFIX}" CACHE PATH "The directory the headers are installed in")
set(CMAKECONFIG_INSTALL_DIR ${LIB_INSTALL_DIR}/cmake/mygpo-qt${MYGPO_QT_VERSION_SUFFIX})

if( APPLE )
    set( CPACK_GENERATOR "DragNDrop" )
    set( CPACK_DMG_FORMAT "UDBZ" )
    set( CPACK_DMG_VOLUME_NAME "libmygpo-qt" )
    set( CPACK_SYSTEM_NAME "OSX" )
endif( APPLE )

include(CPack)

# add a target to generate API documentation with Doxygen
find_package(Doxygen)
if(DOXYGEN_FOUND)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
    add_custom_target(doc ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                         COMMENT "Generating API documentation with Doxygen" VERBATIM
)
endif(DOXYGEN_FOUND)

# make uninstall support
CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

# pkg-config
IF (NOT WIN32)
    FIND_PACKAGE(PkgConfig)
    IF (PKG_CONFIG_FOUND)
        CONFIGURE_FILE (${CMAKE_CURRENT_SOURCE_DIR}/libmygpo-qt.pc.in
                            ${CMAKE_CURRENT_BINARY_DIR}/libmygpo-qt${MYGPO_QT_VERSION_SUFFIX}.pc
                            @ONLY)
         INSTALL (FILES ${CMAKE_CURRENT_BINARY_DIR}/libmygpo-qt${MYGPO_QT_VERSION_SUFFIX}.pc DESTINATION lib${LIB_SUFFIX}/pkgconfig)
    ENDIF (PKG_CONFIG_FOUND)
ENDIF (NOT WIN32)

set(MYGPO_QT_TARGET_NAME mygpo-qt${MYGPO_QT_VERSION_SUFFIX} CACHE INTERNAL "" FORCE )

add_subdirectory( src )
if(MYGPO_BUILD_TESTS)
    add_subdirectory( tests )
endif(MYGPO_BUILD_TESTS)

# This "exports" all targets which have been put into the export set "BarExport".
# This means that cmake generates a file with the given filename, which can later on be loaded
# by projects using this package.
# This file contains add_library(bar IMPORTED) statements for each target in the export set, so
# when loaded later on cmake will create "imported" library targets from these, which can be used
# in many ways in the same way as a normal library target created via a normal add_library().
install(EXPORT ${MYGPO_QT_TARGET_NAME}Export DESTINATION ${CMAKECONFIG_INSTALL_DIR} FILE Mygpo-qt${MYGPO_QT_VERSION_SUFFIX}Targets.cmake )

# figure out the relative path from the installed Config.cmake file to the install prefix (which may be at
# runtime different from the chosen CMAKE_INSTALL_PREFIX if under Windows the package was installed anywhere)
# This relative path will be configured into the BarConfig.cmake
file(RELATIVE_PATH relInstallDir ${CMAKE_INSTALL_PREFIX}/${CMAKECONFIG_INSTALL_DIR} ${CMAKE_INSTALL_PREFIX} )

# Create a BarConfig.cmake file. <name>Config.cmake files are searched by find_package()
# automatically. We configure that file so that we can put any information we want in it,
# e.g. version numbers, include directories, etc.
configure_file(Mygpo-qtConfig.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/Mygpo-qt${MYGPO_QT_VERSION_SUFFIX}Config.cmake @ONLY )

# Additionally, when cmake has found a BarConfig.cmake, it can check for a BarConfigVersion.cmake
# in the same directory when figuring out the version of the package when a version
# has been specified in the find_package() call, e.g. find_package(Bar 1.0)
configure_file(Mygpo-qtConfigVersion.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/Mygpo-qt${MYGPO_QT_VERSION_SUFFIX}ConfigVersion.cmake @ONLY )

# Install these two files into the same directory as the generated exports-file.
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/Mygpo-qt${MYGPO_QT_VERSION_SUFFIX}Config.cmake ${CMAKE_CURRENT_BINARY_DIR}/Mygpo-qt${MYGPO_QT_VERSION_SUFFIX}ConfigVersion.cmake DESTINATION ${CMAKECONFIG_INSTALL_DIR} )

=== src/CMakeLists.txt ===

include_directories( ${QJSON_INCLUDE_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} )

set ( LIBMYGPO_QT_SRC
        Config.cpp
        DeviceSyncResult.cpp
        Settings.cpp
        AddRemoveResult.cpp
        Tag.cpp 
        JsonCreator.cpp 
        Podcast.cpp
        Episode.cpp 
        EpisodeAction.cpp
        EpisodeActionList.cpp
        ApiRequest.cpp
        RequestHandler.cpp
        UrlBuilder.cpp
        TagList.cpp
        EpisodeList.cpp
        PodcastList.cpp
        DeviceUpdates.cpp
        DeviceList.cpp
        Device.cpp
        qjsonwrapper/Json.cpp
)

set ( LIBMYGPO_QT_MOC_H
        Podcast.h
        Podcast_p.h
        PodcastList.h
        PodcastList_p.h
        Episode.h
        Episode_p.h
        EpisodeList.h
        EpisodeList_p.h
        Tag.h
        Tag_p.h
        TagList.h
        TagList_p.h
        Device.h
        Device_p.h
        DeviceList.h
        DeviceList_p.h
        DeviceSyncResult.h
        DeviceSyncResult_p.h
        DeviceUpdates.h
        DeviceUpdates_p.h
        EpisodeAction.h
        EpisodeAction_p.h
        EpisodeActionList.h
        EpisodeActionList_p.h
        Settings.h
        Settings_p.h
        AddRemoveResult.h
        AddRemoveResult_p.h
)

set ( LIBMYGPO_QT_INSTALL_H
        ApiRequest.h
        mygpo_export.h
        Config.h
        Podcast.h
        PodcastList.h
        Episode.h
        EpisodeList.h
        Tag.h
        TagList.h
        Device.h
        DeviceList.h
        DeviceSyncResult.h
        DeviceUpdates.h
        EpisodeAction.h
        EpisodeActionList.h
        Settings.h
        AddRemoveResult.h
)

QT_WRAP_CPP(LIBMYGPO_QT_MOC_SRC ${LIBMYGPO_QT_MOC_H} )

add_library( ${MYGPO_QT_TARGET_NAME} SHARED ${LIBMYGPO_QT_SRC} ${LIBMYGPO_QT_MOC_SRC} )

set_target_properties( ${MYGPO_QT_TARGET_NAME} PROPERTIES VERSION ${MYGPO_QT_VERSION} SOVERSION ${MYGPO_QT_SONAME} DEFINE_SYMBOL MYGPO_MAKEDLL)

if( NOT BUILD_WITH_QT6 )
    target_link_libraries( ${MYGPO_QT_TARGET_NAME} Qt5::Core Qt5::Network)
else()
    target_link_libraries( ${MYGPO_QT_TARGET_NAME} Qt6::Core Qt6::Network)
endif()

install( TARGETS ${MYGPO_QT_TARGET_NAME} EXPORT ${MYGPO_QT_TARGET_NAME}Export DESTINATION ${LIB_INSTALL_DIR} )

install( FILES ${LIBMYGPO_QT_INSTALL_H} DESTINATION  ${INCLUDE_INSTALL_DIR} COMPONENT Devel )

=== tests/CMakeLists.txt ===
########### next target ###############
# QTEST_MAIN is using QApplication when QT_GUI_LIB is defined
remove_definitions(-DQT_GUI_LIB)
remove_definitions(-fvisibility=hidden)
remove_definitions(-DQT_NO_CAST_FROM_ASCII)
remove_definitions(-DQT_NO_CAST_TO_ASCII)

set ( TESTOBJECTS_SRCDIR ${CMAKE_CURRENT_SOURCE_DIR}/../src )

include_directories( ${QJSON_INCLUDE_DIR} ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_BINARY_DIR}/../src ${TESTOBJECTS_SRCDIR} )

# UrlBuilder library
add_library( UrlBuilder ${TESTOBJECTS_SRCDIR}/UrlBuilder.cpp ${TESTOBJECTS_SRCDIR}/Config.cpp )
if( NOT BUILD_WITH_QT6 )
    target_link_libraries( UrlBuilder Qt5::Core )
else()
    target_link_libraries( UrlBuilder Qt6::Core )
endif()
# JSONCreator library
QT_WRAP_CPP(LIBMYGPO_QT_MOC_SRC ${TESTOBJECTS_SRCDIR}/EpisodeAction.h ${TESTOBJECTS_SRCDIR}/EpisodeAction_p.h )
add_library( JsonCreator ${TESTOBJECTS_SRCDIR}/JsonCreator.cpp ${TESTOBJECTS_SRCDIR}/EpisodeAction.cpp ${TESTOBJECTS_SRCDIR}/qjsonwrapper/Json.cpp ${LIBMYGPO_QT_MOC_SRC})
if( NOT BUILD_WITH_QT6 )
    target_link_libraries( JsonCreator Qt5::Core Qt5::Network )
else()
    target_link_libraries( JsonCreator Qt6::Core Qt6::Network )
endif()

set( EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR} )

macro(add_libmygpo_test _source)
    get_filename_component(_name ${_source} NAME_WE)
    QT_WRAP_CPP(${_name}_MOC_SRC ${_name}.h)
    add_executable(${_name} ${_source} ${${_name}_MOC_SRC})
    target_link_libraries(${_name} ${QT_QTCORE_LIBRARY} ${QT_QTTEST_LIBRARY} ${QT_QTNETWORK_LIBRARY})
    add_test(${_name}-test ${EXECUTABLE_OUTPUT_PATH}/${_name})
    if( NOT BUILD_WITH_QT6 )
        target_link_libraries(${_name} Qt5::Network Qt5::Test)
    else()
        target_link_libraries(${_name} Qt6::Network Qt6::Test)
    endif()
endmacro(add_libmygpo_test)

add_libmygpo_test( UrlBuilderTest.cpp )
target_link_libraries( UrlBuilderTest UrlBuilder)

add_libmygpo_test( JsonCreatorTest.cpp )
target_link_libraries( JsonCreatorTest JsonCreator ${QJSON_LIBRARIES} )

=== debian/changelog ===
libmygpo-qt (1.2.0-4) unstable; urgency=medium

  * Team upload.
  * Force the test suites to run with LANG=C & LC_ALL=C & TZ=UTC, as some
    of the tests compare the string representation of values; ideally to be
    done upstream, this should hopefully fix the build on non-English locales.
  * Update symbols files. (Closes: #1117352)

 -- Pino Toscano <pino@debian.org>  Fri, 10 Oct 2025 07:15:43 +0200

libmygpo-qt (1.2.0-3) unstable; urgency=medium

  * Team upload.
  * Update symbols files from the logs of buildds; mark more template
    instantiations as optional. (Closes: #1114175)

 -- Pino Toscano <pino@debian.org>  Mon, 22 Sep 2025 08:53:57 +0200

libmygpo-qt (1.2.0-2) unstable; urgency=medium

  * Team upload.
  * Add the configuration for the CI on salsa.
  * Update symbols files from the logs of buildds. (Closes: #1111787)
  * Trim trailing whitespace.
  * Add a simple debian/upstream/metadata file.
  * Tweak and simpify the install files.

 -- Pino Toscano <pino@debian.org>  Mon, 25 Aug 2025 20:10:25 +0200

libmygpo-qt (1.2.0-1) unstable; urgency=medium

  * Team upload.

  [ Aurélien COUDERC ]
  * RIP Lunar. Adopt the package under the Debian KDE Extras Team’s
    umbrella. Existing uploaders are welcome to continue contributing to
    the packging !
  * Use new git repo location in debian/watch file.
  * Update project homepage.
  * New upstream release (1.2.0).
  * Update build-deps and deps with the info from cmake.
  * Refresh patches.
  * Drop build flag not present anymore in upstream build system.
  * Switch to declarative dh-sequence-pkgkde-symbolshelper.
  * Dual Qt5 / Qt6 build.
  * Update symbols from build for 1.2.0.
  * Add patch to fix failing test case.
  * Build with hardening=+all build hardening flag.
  * Fix package section.
  * Switch build dependency to pkgconf.
  * Bump Standards-Version to 4.7.2, no change required.

 -- Aurélien COUDERC <coucouf@debian.org>  Wed, 13 Aug 2025 22:11:19 +0200

libmygpo-qt (1.1.0-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rebuild against Qt5 5.15.10.
  * debian/libmygpo-qt5-1.symbols: Review symbols:
    + Drop commented missing symbols. They are from standard c++ library and Qt5
      library that should not be tracked here.
    + Drop disappeared symbols in Qt 5.15.10 rebuild (Closes: #1037729). The
      newly-disappeared symbols are all Qt5 symbols that are meaningless here.
  * debian/patches:
    + Re-generate patches using "gbp pq" for unified format.
    + fix-tests-because-qt-isodate-behavior-change.patch: Fix patch format to
      avoid dpkg-source warning "unexpected end of diff".

 -- Boyuan Yang <byang@debian.org>  Sat, 05 Aug 2023 21:43:16 -0400

=== debian/control ===
Source: libmygpo-qt
Section: libs
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@alioth-lists.debian.net>
Uploaders: Thomas Pierson <contact@thomaspierson.fr>,
Build-Depends: debhelper-compat (= 13),
               dh-sequence-pkgkde-symbolshelper,
               cmake (>= 3.5~),
               pkgconf,
               pkg-kde-tools,
               qt6-base-dev,
               qtbase5-dev (>= 5.15.0~),
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/qt-kde-team/3rdparty/libmygpo-qt.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/3rdparty/libmygpo-qt
Homepage: https://gpodder.github.io/docs/libmygpo-qt.html

Package: libmygpo-qt-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmygpo-qt5-1 (= ${binary:Version}),
         qtbase5-dev (>= 5.15.0~),
         ${misc:Depends},
Description: Qt5 development headers for the mygpo-qt library
 C++/Qt Library wrapping the gpodder.net Webservice.
 .
 This package contains the Qt5 development headers for the mygpo-qt library.

Package: libmygpo-qt6-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmygpo-qt6-1 (= ${binary:Version}),
         qt6-base-dev,
         ${misc:Depends},
Description: Qt6 development headers for the mygpo-qt library
 C++/Qt Library wrapping the gpodder.net Webservice.
 .
 This package contains the Qt6 development headers for the mygpo-qt library.

Package: libmygpo-qt5-1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: mygpo-qt library package for Qt 5
 C++/Qt Library wrapping the gpodder.net Webservice.
 .
 This package contains the myqpo-qt library for Qt 5.

Package: libmygpo-qt6-1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: mygpo-qt library package for Qt 6
 C++/Qt Library wrapping the gpodder.net Webservice.
 .
 This package contains the myqpo-qt library for Qt 6.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure --builddirectory=build-qt5
	dh_auto_configure --builddirectory=build-qt6 -- -DBUILD_WITH_QT6=ON

override_dh_auto_build:
	dh_auto_build --builddirectory=build-qt5
	dh_auto_build --builddirectory=build-qt6

override_dh_auto_install:
	dh_auto_install --builddirectory=build-qt5
	dh_auto_install --builddirectory=build-qt6

override_dh_auto_test:
	LANG=C LC_ALL=C TZ=UTC dh_auto_test --builddirectory=build-qt5
	LANG=C LC_ALL=C TZ=UTC dh_auto_test --builddirectory=build-qt6

override_dh_auto_clean:
	dh_auto_clean --builddirectory=build-qt5
	dh_auto_clean --builddirectory=build-qt6

=== debian/watch ===
version=4
https://github.com/gpodder/libmygpo-qt/tags .*/v?(\d.*)@ARCHIVE_EXT@
